/**
 *
 *       @file  i2c_parrot6.h
 *
 *      @brief  
 *
 *     @author  Gregor Boirie <gregor.boirie@parrot.com>
 *       @date  28-May-2010
 *
 *        $Id: i2c_parrot6.h,v 1.1 2010-05-31 12:50:17 gboirie Exp $
 *
 *       Copyright (C) 2008 Parrot S.A.
 */

#ifndef _I2CM_PARROT6_H
#define _I2CM_PARROT6_H

#include <cyg/infra/cyg_type.h>
#include <cyg/kernel/kapi.h>
#include <cyg/io/i2c.h>

struct parrot6_i2c_data {
    CYG_ADDRESS const       base;
    cyg_flag_t              wait_flag;
    cyg_uint32              status;
    char const* const       clk_name;
    unsigned long           hz;
};

extern void         parrot6_i2c_init(cyg_i2c_bus*);
extern cyg_uint32   parrot6_i2c_tx(const cyg_i2c_device*,
                                   cyg_bool,
                                   const cyg_uint8*,
                                   cyg_uint32,
                                   cyg_bool);
extern cyg_uint32   parrot6_i2c_rx(const cyg_i2c_device*,
                                   cyg_bool,
                                   cyg_uint8*,
                                   cyg_uint32,
                                   cyg_bool,
                                   cyg_bool);
extern void         parrot6_i2c_stop(const cyg_i2c_device*);

#define PARROT6_INIT_I2CM_DATA(_base, _clk_name, _hz)   \
    {                                                   \
        .base       = _base,                            \
        .status     = 0,                                \
        .clk_name   = _clk_name,                        \
        .hz         = _hz                               \
    }

#define PARROT6_DEFINE_I2CM_DATA(_name, _base, _clk_name, _hz)          \
    struct parrot6_i2c_data _name = PARROT6_INIT_I2CM_DATA(_base,       \
                                                           _clk_name,   \
                                                           _hz)

#define PARROT6_DEFINE_I2CM_BUS(_name, _extra)  \
    CYG_I2C_BUS(_name,                          \
                &parrot6_i2c_init,              \
                &parrot6_i2c_tx,                \
                &parrot6_i2c_rx,                \
                &parrot6_i2c_stop,              \
                _extra)

#endif

/* vim:set ts=4:sw=4:et:ft=c: */
