/**
 ****************************************************************************
 * Driver for Texas Instrument TPS65023 PMU driver.
 *
 * @file   include/tps65023_regs.h
 * @brief  TPS65023 PMU Registers Description.
 *
 * Code is based on the DS_tps65023.pdf in the doc directory of this package
 *
 * @author Yves LEMOINE
 * @date   2007-04-23
 *
 * 
 * Copyright (C) 2007, Parrot S.A. - www.parrot.com
 ****************************************************************************
 */

#ifndef TPS65023_REGS_H
#define TPS65023_REGS_H



#define TPS65023_ADDRESS   0x48 //!< Texas Instrument TPS65023 PMU Adress on the i2c bus

#define PMU_VERSION		        0x00 //!< 
#define PMU_GOODZ		        0x01 //!< 
#define PMU_MASK		        0x02 //!< 
#define PMU_REG_CTRL	        0x03 //!< 
#define PMU_CON_CTRL	        0x04 //!< 
#define PMU_CON_CTRL2	        0x05 //!< 
#define PMU_DEFCORE		        0x06 //!< 
#define PMU_DEFSLEW		        0x07 //!< 
#define PMU_LDO_CTRL	        0x08 //!< 

typedef struct{
   cyg_uint8  addr;
   cyg_uint16 val;
} wm8960_config_tab_t;

#endif

