/**
 ****************************************************************************
 * Driver for Wolfson WM8731 stereo audio codec.
 *
 * @file   include/WM8731_i2c.h
 * @brief  Wolfson WM8731 Registers Description.
 *
 * Code is based on the WM8731.pdf
 *
 * @author Marc Flambard
 * @date   2007-05-24
 *
 * Copyright (C) 2007, Parrot S.A. - www.parrot.biz
 ****************************************************************************
 */

#ifndef WM8731_I2C_H
#define WM8731_I2C_H

Cyg_ErrNo
WM8731_I2C_AttachBus(WM8731_DEVID devid, const cyg_i2c_bus *bus, cyg_bool ad0);

Cyg_ErrNo
WM8731_I2C_Write(WM8731_DEVID devid, cyg_uint8 addr, const cyg_uint16 data);

#endif
