//==========================================================================
//
//      io/serial/arm/arm_arm9_vpb926ejs_ser.inl
//
//      VPB926EJS Serial I/O definitions
//
//==========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
// Copyright (C) 2004 eCosCentric Ltd.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    nickg
// Contributors: gthomas, jlarmour
// Date:         2004-05-04
// Purpose:      Vpb926ejs Serial I/O module
// Description: 
//
//####DESCRIPTIONEND####
//
//==========================================================================

#include <cyg/hal/hal_intr.h>
#include <cyg/hal/vpb926ejs.h>

//-----------------------------------------------------------------------------

#ifdef CYGPKG_IO_SERIAL_ARM_VPB926EJS_SERIAL0
static pl011_serial_info vpb926ejs_serial_info0 = {VPB926EJS_UART0, CYGNUM_HAL_INTERRUPT_UART0};
#if CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL0_BUFSIZE > 0
static unsigned char vpb926ejs_serial_out_buf0[CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL0_BUFSIZE];
static unsigned char vpb926ejs_serial_in_buf0[CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL0_BUFSIZE];

static SERIAL_CHANNEL_USING_INTERRUPTS(vpb926ejs_channel_serial0,
                                       pl011_serial_funs, 
                                       vpb926ejs_serial_info0,
                                       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL0_BAUD),
                                       CYG_SERIAL_STOP_DEFAULT,
                                       CYG_SERIAL_PARITY_DEFAULT,
                                       CYG_SERIAL_WORD_LENGTH_DEFAULT,
                                       CYG_SERIAL_FLAGS_DEFAULT,
                                       &vpb926ejs_serial_out_buf0[0], sizeof(vpb926ejs_serial_out_buf0),
                                       &vpb926ejs_serial_in_buf0[0], sizeof(vpb926ejs_serial_in_buf0)
    );
#else
static SERIAL_CHANNEL(vpb926ejs_channel_serial0,
                      pl011_serial_funs, 
                      vpb926ejs_serial_info0,
                      CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL0_BAUD),
                      CYG_SERIAL_STOP_DEFAULT,
                      CYG_SERIAL_PARITY_DEFAULT,
                      CYG_SERIAL_WORD_LENGTH_DEFAULT,
                      CYG_SERIAL_FLAGS_DEFAULT
    );
#endif

DEVTAB_ENTRY(vpb926ejs_serial_io0, 
             CYGDAT_IO_SERIAL_ARM_VPB926EJS_SERIAL0_NAME,
             0,                     // Does not depend on a lower level interface
             &cyg_io_serial_devio, 
             pl011_serial_init, 
             pl011_serial_lookup,     // Serial driver may need initializing
             &vpb926ejs_channel_serial0
    );
#endif //  CYGPKG_IO_SERIAL_ARM_VPB926EJS_SERIAL0

//-----------------------------------------------------------------------------

#ifdef CYGPKG_IO_SERIAL_ARM_VPB926EJS_SERIAL1
static pl011_serial_info vpb926ejs_serial_info1 = {VPB926EJS_UART1, CYGNUM_HAL_INTERRUPT_UART1};
#if CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL1_BUFSIZE > 0
static unsigned char vpb926ejs_serial_out_buf1[CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL1_BUFSIZE];
static unsigned char vpb926ejs_serial_in_buf1[CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL1_BUFSIZE];

static SERIAL_CHANNEL_USING_INTERRUPTS(vpb926ejs_channel_serial1,
                                       pl011_serial_funs, 
                                       vpb926ejs_serial_info1,
                                       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL1_BAUD),
                                       CYG_SERIAL_STOP_DEFAULT,
                                       CYG_SERIAL_PARITY_DEFAULT,
                                       CYG_SERIAL_WORD_LENGTH_DEFAULT,
                                       CYG_SERIAL_FLAGS_DEFAULT,
                                       &vpb926ejs_serial_out_buf1[0], sizeof(vpb926ejs_serial_out_buf1),
                                       &vpb926ejs_serial_in_buf1[0], sizeof(vpb926ejs_serial_in_buf1)
    );
#else
static SERIAL_CHANNEL(vpb926ejs_channel_serial1,
                      pl011_serial_funs, 
                      vpb926ejs_serial_info1,
                      CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL1_BAUD),
                      CYG_SERIAL_STOP_DEFAULT,
                      CYG_SERIAL_PARITY_DEFAULT,
                      CYG_SERIAL_WORD_LENGTH_DEFAULT,
                      CYG_SERIAL_FLAGS_DEFAULT
    );
#endif

DEVTAB_ENTRY(vpb926ejs_serial_io1, 
             CYGDAT_IO_SERIAL_ARM_VPB926EJS_SERIAL1_NAME,
             0,                     // Does not depend on a lower level interface
             &cyg_io_serial_devio, 
             pl011_serial_init, 
             pl011_serial_lookup,     // Serial driver may need initializing
             &vpb926ejs_channel_serial1
    );
#endif //  CYGPKG_IO_SERIAL_ARM_VPB926EJS_SERIAL1

//-----------------------------------------------------------------------------

#ifdef CYGPKG_IO_SERIAL_ARM_VPB926EJS_SERIAL2
static pl011_serial_info vpb926ejs_serial_info2 = {VPB926EJS_UART2, CYGNUM_HAL_INTERRUPT_UART2};
#if CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL2_BUFSIZE > 0
static unsigned char vpb926ejs_serial_out_buf2[CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL2_BUFSIZE];
static unsigned char vpb926ejs_serial_in_buf2[CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL2_BUFSIZE];

static SERIAL_CHANNEL_USING_INTERRUPTS(vpb926ejs_channel_serial2,
                                       pl011_serial_funs, 
                                       vpb926ejs_serial_info2,
                                       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL2_BAUD),
                                       CYG_SERIAL_STOP_DEFAULT,
                                       CYG_SERIAL_PARITY_DEFAULT,
                                       CYG_SERIAL_WORD_LENGTH_DEFAULT,
                                       CYG_SERIAL_FLAGS_DEFAULT,
                                       &vpb926ejs_serial_out_buf2[0], sizeof(vpb926ejs_serial_out_buf2),
                                       &vpb926ejs_serial_in_buf2[0], sizeof(vpb926ejs_serial_in_buf2)
    );
#else
static SERIAL_CHANNEL(vpb926ejs_channel_serial2,
                      pl011_serial_funs, 
                      vpb926ejs_serial_info2,
                      CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_VPB926EJS_SERIAL2_BAUD),
                      CYG_SERIAL_STOP_DEFAULT,
                      CYG_SERIAL_PARITY_DEFAULT,
                      CYG_SERIAL_WORD_LENGTH_DEFAULT,
                      CYG_SERIAL_FLAGS_DEFAULT
    );
#endif

DEVTAB_ENTRY(vpb926ejs_serial_io2, 
             CYGDAT_IO_SERIAL_ARM_VPB926EJS_SERIAL2_NAME,
             0,                     // Does not depend on a lower level interface
             &cyg_io_serial_devio, 
             pl011_serial_init, 
             pl011_serial_lookup,     // Serial driver may need initializing
             &vpb926ejs_channel_serial2
    );
#endif //  CYGPKG_IO_SERIAL_ARM_VPB926EJS_SERIAL2

//-----------------------------------------------------------------------------
// EOF arm_arm9_vpb926ejs_ser.inl
