//==========================================================================
// ####ECOSGPLCOPYRIGHTBEGIN####                                            
// -------------------------------------------                              
// This file is part of eCos, the Embedded Configurable Operating System.   
//
// eCos is free software; you can redistribute it and/or modify it under    
// the terms of the GNU General Public License as published by the Free     
// Software Foundation; either version 2 or (at your option) any later      
// version.                                                                 
//
// eCos is distributed in the hope that it will be useful, but WITHOUT      
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or    
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License    
// for more details.                                                        
//
// You should have received a copy of the GNU General Public License        
// along with eCos; if not, write to the Free Software Foundation, Inc.,    
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.            
//
// As a special exception, if other files instantiate templates or use      
// macros or inline functions from this file, or you compile this file      
// and link it with other works to produce a work based on this file,       
// this file does not by itself cause the resulting work to be covered by   
// the GNU General Public License. However the source code for this file    
// must still be made available in accordance with section (3) of the GNU   
// General Public License v2.                                               
//
// This exception does not invalidate any other reasons why a work based    
// on this file might be covered by the GNU General Public License.         
// -------------------------------------------                              
// ####ECOSGPLCOPYRIGHTEND####                                              
//==========================================================================

/**
 * @file   parrot5_lpo.h
 * @brief  Parrot5 LPO hardware register map
 *
 * @author ivan.djelic@parrot.com
 * @date   2008-03-27
 *
 * This file is licensed under the eCos Public License. A copy of this license
 * can be obtained from:
 * http://ecos.sourceware.org/license-overview.html
 *
 * The Original Code is eCos - Embedded Configurable Operating System,
 *
 * Portions created by Parrot S.A. are
 * Copyright (C) 2004-2008 Parrot S.A.
 */

#ifndef PARROT5_LPO_H
#define PARROT5_LPO_H

#define _LPO_STATUS             0x00 // LPO REad-Only Status register
#define _LPO_CONTROL            0x04 // LPO Control register
#define _LPO_ITACK              0x08 // LPO interrupt acknowledge register
#define _LPO_RTCCNT             0x0C // LPO RTC counter register
#define _LPO_RTCA               0x10 // LPO RTC alarm register
#define _LPO_SCRATCH            0x14 // LPO Scratch register
#define _LPO_EMCYDET            0x18 // LPO Emergency Detection params register
#define _LPO_EMCYTRIG           0x1C // LPO Emergency Trigger params register

// Bitwise definitions
#define LPO_STATUS_EMERCY       (1 << 10)
#define LPO_STATUS_ALARM        (1 << 9)
#define LPO_STATUS_WKUP         (1 << 8)
#define LPO_STATUS_EMERCY_EV    (1 << 2)
#define LPO_STATUS_ALARM_EV     (1 << 1)
#define LPO_STATUS_WKUP_EV      (1 << 0)

#define LPO_CTRL_WKUP_EN        (1 << 0)
#define LPO_CTRL_ALARM_EN       (1 << 1)
#define LPO_CTRL_EMCY_LVL       (1 << 2)
#define LPO_CTRL_WKUP_LVL       (1 << 3)
#define LPO_CTRL_EMCY_EN        (1 << 4)
#define LPO_CTRL_EMCY_MOD       (1 << 5)
#define LPO_CTRL_32K_MOD        (1 << 6)
#define LPO_CTRL_WRITE_STAT     (1 << 7)

#define LPO_ITACK_RTCA          (1 << 0)
#define LPO_ITACK_EMCY          (1 << 1)
#define LPO_ITACK_WKUP          (1 << 2)

#endif /* PARROT5_LPO_H */
