//==========================================================================
// ####ECOSGPLCOPYRIGHTBEGIN####                                            
// -------------------------------------------                              
// This file is part of eCos, the Embedded Configurable Operating System.   
//
// eCos is free software; you can redistribute it and/or modify it under    
// the terms of the GNU General Public License as published by the Free     
// Software Foundation; either version 2 or (at your option) any later      
// version.                                                                 
//
// eCos is distributed in the hope that it will be useful, but WITHOUT      
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or    
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License    
// for more details.                                                        
//
// You should have received a copy of the GNU General Public License        
// along with eCos; if not, write to the Free Software Foundation, Inc.,    
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.            
//
// As a special exception, if other files instantiate templates or use      
// macros or inline functions from this file, or you compile this file      
// and link it with other works to produce a work based on this file,       
// this file does not by itself cause the resulting work to be covered by   
// the GNU General Public License. However the source code for this file    
// must still be made available in accordance with section (3) of the GNU   
// General Public License v2.                                               
//
// This exception does not invalidate any other reasons why a work based    
// on this file might be covered by the GNU General Public License.         
// -------------------------------------------                              
// ####ECOSGPLCOPYRIGHTEND####                                              
//==========================================================================

/**
 * ============================================================================
 * @file  thread.h
 * @brief Thread handling functions
 *
 * Memory protection thread handling.
 *
 * Copyright (C) 2004,2005 Parrot S.A.
 *
 * @author     ivan.djelic@parrot.fr
 * @date       2004-05-04
 * ============================================================================
 */

#ifndef CYGONCE_MEMPROT_THREAD_H
#define CYGONCE_MEMPROT_THREAD_H

#include <cyg/kernel/kapi.h>

void cyg_memprot_thread_create( cyg_addrword_t      sched_info,
				cyg_thread_entry_t  *entry,
				cyg_addrword_t      entry_data,
				char                *name,
				void                *stack_base,
				cyg_ucount32        stack_size,
				cyg_handle_t        *handle,
				cyg_thread          *thread );

void cyg_memprot_thread_delete(cyg_handle_t thread);

int cyg_memprot_get_current_domain(cyg_uint32 addr);
void cyg_memprot_thread_exit(void);

#endif // CYGONCE_MEMPROT_THREAD_H
