
#include <pkgconf/system.h>
#include <pkgconf/net.h>

#include <network.h>

#include <netinet/in.h>
#include <netinet/if_ether.h>


//#define CYGDBG_NET_ZCIP_CHATTER

#define ZCIP_IFTABLE_MAXENTRIES 5 ///< Max number of entries
#define ZCIP_INTF_MAXLEN 7 ///< Max size of intf string

#define PROBE_NUM            3 ///< number of probe packets (RFC2937)
#define ANNOUNCE_NUM         2 ///< number of announcement packets (RFC2937)
#define MAX_CONFLICTS       10 ///< max conflicts before rate limiting (RFC2937)

#define IP_ADDR_LEN 4  ///< Length of ip address char[]
/** Inside ARP_PACKET_LEN fits a full ARP _PACKET composed by a 
 * "struct ether_header" of size ETHER_HDR_LEN 
 * followed by a  "struct ether_arp" */
#define ARP_PACKET_LEN ( ETHER_HDR_LEN + 8 + (2 * ETHER_ADDR_LEN) + (2 * IP_ADDR_LEN))

/** States during the configuration process. */
enum {
	PROBE = 0,
	RATE_LIMIT_PROBE,
	ANNOUNCE,
	MONITOR,
	DEFEND
};

/** Structure to store a known interface */
struct zcip_ifentry{
	char intf[ZCIP_INTF_MAXLEN];
	struct ether_addr mac_addr;
	struct in_addr ip_addr;
};

int do_zcip(const char *interface, struct bootp *res, bool defend);
