/**
*******************************************************************************
* @file  dlmallocuserd.h
* @brief Memory allocator data types
*
* User mode memory allocation.
*
* Copyright (C) 2004,2005 Parrot S.A.
*
* @author     ivan.djelic@parrot.fr
* @date       2004-06-28
*******************************************************************************
*/
#ifndef CYGONCE_MEMALLOC_DLMALLOCUSER_DATA_H
#define CYGONCE_MEMALLOC_DLMALLOCUSER_DATA_H

/* TYPE DEFINITIONS */

#define CYGPRI_MEMALLOC_ALLOCATOR_DLMALLOCUSER_NAV 128

typedef size_t cyg_mempool_dlmalloc_size_t;

typedef struct mempool_malloc_chunk {
    cyg_mempool_dlmalloc_size_t prev_size; /* Size of prev chunk (if free).*/
    cyg_mempool_dlmalloc_size_t size;   /* Size in bytes, incl. overhead. */
    struct mempool_malloc_chunk* fd;   /* double links -- used only if free. */
    struct mempool_malloc_chunk* bk;
} mempool_malloc_chunk_t;

typedef struct cyg_mempool_dlmalloc {
    cyg_uint8 *arenabase;
    cyg_int32 arenasize;

    struct mempool_malloc_chunk *
    av_[ CYGPRI_MEMALLOC_ALLOCATOR_DLMALLOCUSER_NAV * 2 + 2 ];

    unsigned long trim_threshold;
    unsigned long top_pad;
    cyg_uint8 * sbrk_base;
    unsigned long sbrked_mem;
    unsigned long max_sbrked_mem;
    unsigned long max_total_mem;
    int sbrk_enabled;
    void *process;
} cyg_mempool_dlmalloc_t;

typedef struct cyg_mempool_dlmalloc cyg_mempool_dlmalloc;

#endif // CYGONCE_MEMALLOC_DLMALLOCUSER_DATA_H
