/**
*******************************************************************************
* @file  rtmon_hal.h
* @brief Real-Time Monitor / HAL-dependent routines and constants
*
* Copyright (C) 2006 Parrot S.A.
*
* @author     ivan.djelic@parrot.fr
* @date       2006-12-01
*******************************************************************************
*/
#ifndef CYGONCE_RTMON_HAL_H
#define CYGONCE_RTMON_HAL_H

#include <cyg/hal/hal_io.h>         // I/O macros
#include <cyg/kernel/kapi.h>
#include <cyg/infra/diag.h>         // diagnostic output
#include <cyg/hal/drv_api.h>

#include <cyg/rtmon/rtmon.h>
#include <cyg/rtmon/rtmon_internal.h>


#ifdef CYGPKG_HAL_ARM_ARM9_SMDK2412
#include <cyg/rtmon/rtmon_hal_s3c2412.h>
#elif defined(CYGPKG_HAL_ARM_ARM9_P5DEV)
#include <cyg/rtmon/rtmon_hal_p5.h>
#elif defined(CYGPKG_HAL_ARM_ARM9_P6DEV)
#include <cyg/rtmon/rtmon_hal_p6.h>
#else
#error Unsupported architecture
#endif


extern void rtmon_hal_start_profiling(void);
extern void rtmon_hal_stop_profiling (void);
extern void rtmon_hal_start_timer    (void);
extern void rtmon_hal_stop_timer     (void);

//Function to call to init specific data
extern void rtmon_hal_init_var       (void);

#endif /* CYGONCE_RTMON_HAL_H */
