
/**
 ******************************************************************************
 * @file  rtmon_handler.S 
 * @brief This SWI routine logs PC on FIQ exception
 *
 * Copyright (C) 2004,2005 Parrot S.A.
 *
 * @author   ivan.djelic@parrot.fr
 * @date     2004-05-26
 * @author   raphael.lemoine@parrot.com
 * @date     2007-06-14
 * @author   gregoire.etienne@parrot.com
 * @date     2007-06-14
 ******************************************************************************
 */

#include <pkgconf/system.h>
#include <pkgconf/rtmon.h>

    .code   32
    .text
    .section        ".text.swi_rtmon_handler","ax"
    .global swi_rtmon_handler
    .xref   rtmon

#ifndef CYGPKG_HAL_ARM_ARM9_SMDK2412

swi_rtmon_handler:
    mov     r8, #0xD0000000         /*  SYSC                    */

#if defined(CYGPKG_HAL_ARM_ARM9_P6DEV)
    ldr     r9, [r8, #0x12C]        /*  _P6_SYS_TIM3CNT         */
    mov     r9, r9, lsr #1
    ldr     r10,[r8]                /*  _P6_SYS_STATUS          */
    mov     r11, #0x0B00
    tst     r10, #0x10
    ldr     r12, =0x8               /* FLAG TIMER 2 = (1<<3)    */
    ldr     r9, [r8, #0x12C]
    mov     r9, r9, lsr #1
    str     r12,[r8, #0x8]          /* acknowledge FLAG TIMER 2 */
#elif defined(CYGPKG_HAL_ARM_ARM9_P5DEV)
    ldr     r9, [r8, #0x1C]         /*  _SYS_TIM3VAL            */
    ldr     r10,[r8, #0x24]         /*  _SYS_FLAGS              */
    mov     r11, #0x0B00
    tst     r10, #0x10
    ldr     r12, =0x8               /* FLAG TIMER 2 = (1<<3)    */
    ldr     r9, [r8, #0x1C]
    str     r12,[r8, #0x24]         /* acknowledge FLAG TIMER 2 */
#endif

    and     r10, r10, #0x10
    orr     r10, r11, r10, lsl #11  /* set pkt header with pending bit */
    orr     r10, r10, lr, lsr #24
    orr     r8, r9, r10, lsl #16
/*  0f001011 llllllll tttttttt tttttttt */

    ldr     r9, =rtmon
    ldr     r10, [r9, #4]            /* rtmon.buf       :buffer index       */
    ldr     r11, [r9, #8]            /* rtmon.buf_index :buffer base address*/
    str     r8, [r11, r10, lsl #2]

    add     r10, r10, #1
    cmp     r10, #(CYGPKG_RTMON_LOGSIZE << 8)
    movge   r10, #0

    mov     r8, #0x01000000
    sub     r8, r8, #1
    and     r8, r8, lr
    orr     r8, r8, #0x08000000
/*  00001000 llllllll llllllll llllllll */

    str     r8, [r11, r10, lsl #2]

    add     r10, r10, #1
    cmp     r10, #(CYGPKG_RTMON_LOGSIZE << 8)
    movge   r10, #0

    str     r10, [r9, #4]

    subs    pc,lr,#4                /* return from FIQ */

#endif

